<!--
  @component
  Generates an SVG column chart. It uses the z-scale for color assignments and
  assumes both `xScale` and `zScale` are ordinal scales.  It assumes your data
  is in a [D3 stack format](https://github.com/d3/d3-shape#stack
  -->
<script>
  import { getContext } from 'svelte';
  import { ScoresDataStore } from '@components/ScoreChart/scoresDataStore';

  const { data, xGet, yGet, zGet, xScale, xPadding } = getContext('LayerCake');
</script>

<g class="column-group">
  {#each $data as series, i}
    {#each series as d}
      {@const xTransform = $xGet(d) + $xPadding[0]}
      {@const yValues = $yGet(d)}
      {@const columnHeight = yValues[0] - yValues[1]}
      {#if i === $data.length - 1}
        <g class="block-total">
          <text
            transform="translate(
            {xTransform + $xScale.bandwidth() / 2},
            {yValues[1] - 5})"
          >
            {Math.floor(d[1])}
          </text>
        </g>
      {/if}
      <rect
        on:mouseenter={() => ScoresDataStore.set(d.data)}
        on:mouseleave={() => ScoresDataStore.set(null)}
        class="group-rect"
        data-id={i}
        x={xTransform}
        y={yValues[1]}
        width={$xScale.bandwidth()}
        height={columnHeight}
        fill={$zGet(series)}
      />
      {#if columnHeight > 25}
        <g class="block-score">
          <text
            transform="translate(
            {xTransform + $xScale.bandwidth() / 2},
            {yValues[1] + columnHeight / 2 + 10})"
          >
            {Math.floor(d[1] - d[0])}
          </text>
        </g>
      {/if}
    {/each}
  {/each}
</g>

<style>
  .block-total text,
  .block-score text {
    pointer-events: none; /* otherwise hovering over the text hides the score popup */
    font-family: 'Unica One', sans-serif;
    font-weight: bold;
    text-anchor: middle;
    stroke: #000000;
    stroke-width: 1px;
    stroke-linejoin: round;
  }
  .block-total text {
    fill: #ffffff;
    font-size: 36px;
  }
  .block-score text {
    fill: #a3a3a3;
    font-size: 30px;
  }
  .group-rect {
    stroke: white;
  }
</style>
